var search_data = {"index":{"searchIndex":["packedstruct","directive","modifier","package","unknownmodifiererror","+()","-()","[]()","add_modifier()","bytesize()","cache_string()","coerce()","compile!()","directives()","empty?()","fast_unpack()","finalize!()","finalize_directives!()","finalized?()","handle_empty_type()","handle_float_type()","handle_string_type()","has_field?()","included()","inspect()","method_missing()","modify_for_endianness()","modify_if_needed()","new()","new()","new()","pack()","size()","struct()","struct_layout()","structs()","tags_for_sized_directive()","to_s()","to_s()","to_str()","type()","undefined_size?()","unpack()","unpack_from_socket()","value()"],"longSearchIndex":["packedstruct","packedstruct::directive","packedstruct::modifier","packedstruct::package","packedstruct::unknownmodifiererror","packedstruct::directive#+()","packedstruct::directive#-()","packedstruct::directive#[]()","packedstruct::directive#add_modifier()","packedstruct::directive#bytesize()","packedstruct::directive#cache_string()","packedstruct::directive#coerce()","packedstruct::modifier#compile!()","packedstruct::package#directives()","packedstruct::directive#empty?()","packedstruct::package#fast_unpack()","packedstruct::directive#finalize!()","packedstruct::package#finalize_directives!()","packedstruct::directive#finalized?()","packedstruct::directive#handle_empty_type()","packedstruct::directive#handle_float_type()","packedstruct::directive#handle_string_type()","packedstruct::package#has_field?()","packedstruct::included()","packedstruct::package#inspect()","packedstruct::package#method_missing()","packedstruct::directive#modify_for_endianness()","packedstruct::directive#modify_if_needed()","packedstruct::directive::new()","packedstruct::modifier::new()","packedstruct::package::new()","packedstruct::package#pack()","packedstruct::directive#size()","packedstruct#struct()","packedstruct#struct_layout()","packedstruct#structs()","packedstruct::directive#tags_for_sized_directive()","packedstruct::directive#to_s()","packedstruct::package#to_s()","packedstruct::package#to_str()","packedstruct::modifier#type()","packedstruct::directive#undefined_size?()","packedstruct::package#unpack()","packedstruct::package#unpack_from_socket()","packedstruct::modifier#value()"],"info":[["PackedStruct","","PackedStruct.html","","<p>Create structs to manage packed strings.\n"],["PackedStruct::Directive","","PackedStruct/Directive.html","",""],["PackedStruct::Modifier","","PackedStruct/Modifier.html","",""],["PackedStruct::Package","","PackedStruct/Package.html","","<p>Manages the struct overall, and keeps track of the directives. Directives are packed in the order that …\n"],["PackedStruct::UnknownModifierError","","PackedStruct/UnknownModifierError.html","",""],["+","PackedStruct::Directive","PackedStruct/Directive.html#method-i-2B","(other)","<p>(see #-)\n"],["-","PackedStruct::Directive","PackedStruct/Directive.html#method-i-2D","(other)","<p>Modifies <code>self</code> such that it sizes itself (on {#to_s}ing), and keeping this size modification in mind. …\n"],["[]","PackedStruct::Directive","PackedStruct/Directive.html#method-i-5B-5D","(new_size)","<p>Changes the size of the directive to the given size.  It is possible for the given value to the a directive; …\n"],["add_modifier","PackedStruct::Directive","PackedStruct/Directive.html#method-i-add_modifier","(mod)","<p>Add a modifier to this directive.\n<p>@param mod [Modifier] @return [self]\n"],["bytesize","PackedStruct::Directive","PackedStruct/Directive.html#method-i-bytesize","(data = {})","<p>The number of bytes this takes up in the resulting packed string.\n<p>@param (see #to_s) @return [Numeric] …\n"],["cache_string","PackedStruct::Directive","PackedStruct/Directive.html#method-i-cache_string","()","<p>Tries to cache the string value of this directive.  It cannot if <code>tags[:size]</code> is a Symbol, since it depends …\n"],["coerce","PackedStruct::Directive","PackedStruct/Directive.html#method-i-coerce","(other)","<p>Coerces <code>self</code> into a format that can be used with <code>Numeric</code> to add or subtract from this class.\n<p>@example …\n"],["compile!","PackedStruct::Modifier","PackedStruct/Modifier.html#method-i-compile-21","()","<p>Compiles the modifier into a usable format.  Stores the values it determines in +@type+ and +@value+. …\n"],["directives","PackedStruct::Package","PackedStruct/Package.html#method-i-directives","()","<p>The list of directives that the package has.\n<p>@return [Array&lt;Directive&gt;]\n"],["empty?","PackedStruct::Directive","PackedStruct/Directive.html#method-i-empty-3F","()","<p>Determines whether or not this directive is empty.  It is considered empty when its tags has all of the …\n"],["fast_unpack","PackedStruct::Package","PackedStruct/Package.html#method-i-fast_unpack","(string)","<p>This unpacks the entire string at once.  It assumes that none of the directives will need the values …\n"],["finalize!","PackedStruct::Directive","PackedStruct/Directive.html#method-i-finalize-21","()","<p>Finalizes the directive.\n<p>@return [void]\n"],["finalize_directives!","PackedStruct::Package","PackedStruct/Package.html#method-i-finalize_directives-21","()","<p>Finalizes all of the directives.\n<p>@return [void]\n"],["finalized?","PackedStruct::Directive","PackedStruct/Directive.html#method-i-finalized-3F","()","<p>Whether or not this directive has finalized.  It is finalized until a modifier is added, and then {#finalize!} …\n"],["handle_empty_type","PackedStruct::Directive","PackedStruct/Directive.html#method-i-handle_empty_type","()","<p>Handles the type if there is no type, i.e. a type modifier was not specified.  Can only handle directives …\n"],["handle_float_type","PackedStruct::Directive","PackedStruct/Directive.html#method-i-handle_float_type","()","<p>Handles the float type.  Handles the endianness and the precision, returning the correct character for …\n"],["handle_string_type","PackedStruct::Directive","PackedStruct/Directive.html#method-i-handle_string_type","()","<p>Handles the type if it is string.  Defaults to a null-padded string, but if a <code>:hex</code>, <code>:base64</code>, or <code>:bit</code> …\n"],["has_field?","PackedStruct::Package","PackedStruct/Package.html#method-i-has_field-3F","(field)","<p>Checks to see if it has a field with the given name.\n<p>@return [Boolean]\n"],["included","PackedStruct","PackedStruct.html#method-c-included","(reciever)","<p>Called when this is included into another module.\n<p>@api private @param reciever [Module] the reciever that …\n"],["inspect","PackedStruct::Package","PackedStruct/Package.html#method-i-inspect","()","<p>Inspects the package.\n<p>@return [String]\n"],["method_missing","PackedStruct::Package","PackedStruct/Package.html#method-i-method_missing","(method, *arguments, &block)","<p>Creates a new directive with the given method and arguments.\n<p>@return [Directive] the new directive.\n"],["modify_for_endianness","PackedStruct::Directive","PackedStruct/Directive.html#method-i-modify_for_endianness","(str, use_case = false)","<p>Modifies the given string to account for endianness.  If <code>use_case</code> is true, it modifies the case of the …\n"],["modify_if_needed","PackedStruct::Directive","PackedStruct/Directive.html#method-i-modify_if_needed","(str, include_endian = true)","<p>Modifies the given string if it’s needed, according to signness and endianness.  This assumes that …\n"],["new","PackedStruct::Directive","PackedStruct/Directive.html#method-c-new","(name)","<p>Initialize the directive.\n<p>@param name [Symbol] the name of the directive. @param package [Package] the …\n"],["new","PackedStruct::Modifier","PackedStruct/Modifier.html#method-c-new","(name)","<p>Initializes the modifier.\n"],["new","PackedStruct::Package","PackedStruct/Package.html#method-c-new","()","<p>Initialize the package.\n"],["pack","PackedStruct::Package","PackedStruct/Package.html#method-i-pack","(data)","<p>Packs the given data into a string.  The keys of the data correspond to the names of the directives. …\n"],["size","PackedStruct::Directive","PackedStruct/Directive.html#method-i-size","(data = {})","<p>The size of this directive.\n<p>@param (see #to_s) @return [nil, Numeric]\n"],["struct","PackedStruct","PackedStruct.html#method-i-struct","()",""],["struct_layout","PackedStruct","PackedStruct.html#method-i-struct_layout","(name = nil, &block)","<p>Define a struct.  The name will be used for {#structs}, and the block will run in the context of a {Package}. …\n"],["structs","PackedStruct","PackedStruct.html#method-i-structs","()","<p>The structs that were defined on the module that included this. If the structs were defined without a …\n"],["tags_for_sized_directive","PackedStruct::Directive","PackedStruct/Directive.html#method-i-tags_for_sized_directive","()","<p>Returns a hash to be merged into the tags of a directive that recieved this directive for a size.\n<p>@return …\n"],["to_s","PackedStruct::Directive","PackedStruct/Directive.html#method-i-to_s","(data = {})","<p>Turn the directive into a string, with the given data.  It shouldn’t need the data unless <code>tags[:size]</code> …\n"],["to_s","PackedStruct::Package","PackedStruct/Package.html#method-i-to_s","(data = {})","<p>Turn the package into a string.  Uses the directives (calls {Directive#to_s} on them), and joins the …\n"],["to_str","PackedStruct::Package","PackedStruct/Package.html#method-i-to_str","(data = {})",""],["type","PackedStruct::Modifier","PackedStruct/Modifier.html#method-i-type","()","<p>The type of modifier it is.  Has four possible values: <code>:endian</code>, <code>:size</code>, <code>:length</code>, <code>:type</code>, <code>:string_type</code>, …\n"],["undefined_size?","PackedStruct::Directive","PackedStruct/Directive.html#method-i-undefined_size-3F","()","<p>Returns whether or not this directive depends on another directive for its value.\n<p>@return [Boolean]\n"],["unpack","PackedStruct::Package","PackedStruct/Package.html#method-i-unpack","(string)","<p>Unpacks the given string with the directives.  Returns a hash containing the values, with the keys being …\n"],["unpack_from_socket","PackedStruct::Package","PackedStruct/Package.html#method-i-unpack_from_socket","(sock)","<p>Unpacks from a socket.\n<p>@param sock [#read] the socket to unpack from. @return [Hash&lt;Symbol, Object&gt;] …\n"],["value","PackedStruct::Modifier","PackedStruct/Modifier.html#method-i-value","()","<p>The value of the modifier.  Has multiple possible values, including: <code>:little</code>, <code>:big</code>, <code>:short</code>, <code>:int</code>, <code>:long</code> …\n"]]}}